Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Create.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Create.aspx	(revision 6243)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Create.aspx	(revision 6243)
@@ -0,0 +1,29 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Create
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Create</h2>
+
+    <% using (Html.BeginForm()) {%>
+        <%: Html.ValidationSummary(true) %>
+
+        <fieldset>
+            <legend>Create Algorithm Class</legend>
+            <%: Html.EditorFor(model => ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass)%>
+            <p>
+                <input type="submit" value="Createx" />
+            </p>
+        </fieldset>
+
+    <% } %>
+
+    <div>
+        <%: Html.ActionLink("Back to List", "Index") %>
+    </div>
+
+</asp:Content>
+
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Delete.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Delete.aspx	(revision 6243)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Delete.aspx	(revision 6243)
@@ -0,0 +1,24 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Delete
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Delete</h2>
+
+    <p>Are you sure you want to delete AlgorithmClass <strong><%: ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass.Name%></strong>?</p>
+    <fieldset>
+        <legend>Fields</legend>
+        
+    </fieldset>
+    <% using (Html.BeginForm()) { %>
+        <p>
+		    <input type="submit" value="Delete" /> |
+		    <%: Html.ActionLink("Back to List", "Index") %>
+        </p>
+    <% } %>
+
+</asp:Content>
+
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Details.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Details.aspx	(revision 6243)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Details.aspx	(revision 6243)
@@ -0,0 +1,21 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Details
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Details</h2>
+
+    <fieldset>
+        <legend>Detail AlgorithmClass</legend>
+        <%: Html.EditorFor(model => ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass)%>
+    </fieldset>
+    <p>
+        <%: Html.ActionLink("Edit", "Edit", new { id = ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass.Id })%> |
+        <%: Html.ActionLink("Back to List", "Index") %>
+    </p>
+
+</asp:Content>
+
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Edit.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Edit.aspx	(revision 6243)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Edit.aspx	(revision 6243)
@@ -0,0 +1,25 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Edit
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Edit</h2>
+
+    <% using (Html.BeginForm()) {%>
+        <%: Html.ValidationSummary(true) %>
+        
+        <fieldset>
+            <legend>Edit AlgorithmClass</legend>
+            <%: Html.EditorFor(model => ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass)%>
+            <p>
+                <input type="submit" value="Save" />
+            </p>
+        </fieldset>
+
+    <% } %>
+
+</asp:Content>
+
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Index.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Index.aspx	(revision 6243)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass_old/Index.aspx	(revision 6243)
@@ -0,0 +1,45 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Index
+</asp:Content>
+    
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <form id="form1" runat="server">
+
+
+    <h2>AlgorithmClasses</h2>
+    
+    <asp:Panel ID="pMenu" runat="server">
+    </asp:Panel>
+    <p>
+        <asp:ListBox ID="lbAlgorithmClasses" runat="server" DataSourceID="ODSAlgorithmClasses" 
+            DataTextField="Name" DataValueField="Id" Height="350px" style="margin-top: 0px" 
+            Width="246px">
+        </asp:ListBox>
+        <asp:ObjectDataSource ID="ODSAlgorithmClasses" runat="server" 
+            SelectMethod="AlgorithmClassGetAll" 
+            TypeName="HLWebPluginHost.Models.AlgorithmClassModel">
+        </asp:ObjectDataSource>
+        
+
+    </p>
+   
+
+    <asp:Panel ID="pDetailAlgorithmClass" runat="server" Height="139px">
+        <asp:Label ID="lbName" runat="server" Text="Name:"></asp:Label>
+        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
+        <asp:TextBox ID="txtName1" runat="server" Width="197px"></asp:TextBox>
+        <br />
+        Description:
+        <asp:TextBox ID="txtDescription" runat="server" Width="197px"></asp:TextBox>
+    </asp:Panel>
+   
+
+    </form>
+
+   
+
+</asp:Content>