Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Details.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Details.aspx	(revision 6253)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Details.aspx	(revision 6253)
@@ -0,0 +1,17 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" ViewStateMode="Enabled" EnableEventValidation="true"  %>
+
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu"); %>
+</asp:Content>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Details
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Details</h2>
+    
+        <% Html.RenderAction("RunCollectionDetail");  %>
+
+</asp:Content>
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Menu.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Menu.ascx	(revision 6247)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/Menu.ascx	(revision 6253)
@@ -8,4 +8,9 @@
     <%: Html.ActionLink("Results", "Results", "Query") %>
 </li>
+<% if (Session["QueryRunDetailId"] != null) { %>
+<li <% if(Session["SelectedSubMenu"] == "Details") {%> class="selected" <%}%>>
+    <%: Html.ActionLink("Details", "Details", "Query")%>
+</li>
+<% } %>
 <li <% if(Session["SelectedSubMenu"] == "Chart") {%> class="selected" <%}%>>
     <%: Html.ActionLink("Chart", "Index", "Chart") %>
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx	(revision 6247)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx	(revision 6253)
@@ -1,8 +1,62 @@
-﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="RunCollectionDetail.ascx.cs" Inherits="HLWebOKBQueryPlugin.Views.Query.RunCollectionDetail" %>
+﻿<%@ Control Language="C#" Inherits="System.Web.Mvc.ViewUserControl" %>
+<%@ Import Namespace="HLWebOKBQueryPlugin.Helpers" %>
+<%@ Import Namespace="System.Reflection"  %>
 
-<asp:Table ID="TableRunDetail" runat="server">
-    <asp:TableHeaderRow>
-        <asp:TableHeaderCell Text="Property" />
-        <asp:TableHeaderCell Text="Value" />
-    </asp:TableHeaderRow>
-</asp:Table>
+<div id="RunDetailProperties">
+<table><tr><td>
+    <table>
+        <thead>
+            <tr><th colspan="3">Result</th></tr>
+        </thead>
+        <tbody>
+            <% IResult result = (RunCollectionData)Session["QueryRunDetail"];
+               foreach (PropertyInfo pi in typeof(IResult).GetProperties()) {
+                   RouteValueDictionary rvd = new RouteValueDictionary();
+                   rvd.Add("controller", "Query");
+                   rvd.Add("id", pi.Name); %>
+            <tr>
+                <td style="width: 5%;"><%= Ajax.ActionLink("detail", "DetailValue", rvd, new AjaxOptions { UpdateTargetId = "ctrlValue" })%></td>
+                <td style="width: 45%;"><%= pi.Name %></td>
+                <td>
+                    <% try { %>
+                            <%= pi.GetValue(result, null).ToString()%>
+                    <%     } catch (Exception e) { %>
+                            &nbsp;
+                    <%     } %>
+                </td>
+            </tr>
+            <% } %>
+        </tbody>
+    </table>
+
+    <table>
+        <thead>
+            <tr><th colspan="3">Parameter</th></tr>
+        </thead>
+        <tbody>
+            <% IParams parameters = (RunCollectionData)Session["QueryRunDetail"];
+               foreach (PropertyInfo pi in typeof(IParams).GetProperties()) {
+                   RouteValueDictionary rvd = new RouteValueDictionary();
+                   rvd.Add("controller", "Query");
+                   rvd.Add("id", pi.Name); %>
+            <tr>
+                <td style="width: 5%;"><%= Ajax.ActionLink("detail", "DetailValue", rvd, new AjaxOptions { UpdateTargetId = "ctrlValue" })%></td>
+                <td style="width: 45%;"><%= pi.Name %></td>
+                <td>
+                    <% try { %>
+                            <%= pi.GetValue(parameters, null).ToString()%>
+                    <%     } catch (Exception e) { %>
+                            &nbsp;
+                    <%     } %>
+                </td>
+            </tr>
+            <% } %>
+        </tbody>
+    </table>
+</td>
+<td style="vertical-align: top;">
+    <div>
+        <div id="ctrlValue"><label>Value:</label><input type="text" value="" /></div>
+    </div>
+</td></tr></table>
+</div>
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx.cs	(revision 6247)
+++ 	(revision )
@@ -1,63 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Web;
-using System.Web.UI;
-using System.Web.UI.WebControls;
-
-using System.Reflection;
-
-using HLWebOKBQueryPlugin.Helpers;
-
-namespace HLWebOKBQueryPlugin.Views.Query {
-    public partial class RunCollectionDetail : System.Web.UI.UserControl {
-        private object currentObject = null;
-        public object detailObject {
-            get { return currentObject; }
-            set {
-                currentObject = value;
-                FillDetails();
-            }
-        }
-
-        protected void Page_Load(object sender, EventArgs e) {
-            currentObject = getTest();
-
-            FillDetails();
-        }
-
-        protected void FillDetails() {
-            if (currentObject != null) {
-                Type rcd = currentObject.GetType();
-
-                foreach (PropertyInfo pi in rcd.GetProperties()) {
-                    TableRow tr = new TableRow();
-                    TableCell tc = new TableCell();
-                    tc.Text = pi.Name;
-                    tr.Cells.Add(tc);
-                    tc = new TableCell();
-                    try {
-                        tc.Text = pi.GetValue(currentObject, null).ToString();
-                    } catch (Exception ex) {
-                        tc.Text = ex.Message;
-                    }
-                    tr.Cells.Add(tc);
-                    TableRunDetail.Rows.Add(tr);
-                }
-            }
-        }
-
-        private RunCollectionData getTest() {
-            OKBQueryService.Run testrun = new OKBQueryService.Run();
-
-            testrun.Id = 34;
-            testrun.Algorithm = new OKBQueryService.Algorithm();
-            testrun.Algorithm.Name = "TestAlgo";
-            testrun.Algorithm.AlgorithmClass = "TestAlgoClass";
-
-            RunCollectionData run = new RunCollectionData(testrun);
-            
-            return run;
-        }
-    }
-}
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx.designer.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionDetail.ascx.designer.cs	(revision 6247)
+++ 	(revision )
@@ -1,24 +1,0 @@
-﻿//------------------------------------------------------------------------------
-// <auto-generated>
-//     This code was generated by a tool.
-//
-//     Changes to this file may cause incorrect behavior and will be lost if
-//     the code is regenerated. 
-// </auto-generated>
-//------------------------------------------------------------------------------
-
-namespace HLWebOKBQueryPlugin.Views.Query {
-    
-    
-    public partial class RunCollectionDetail {
-        
-        /// <summary>
-        /// TableRunDetail control.
-        /// </summary>
-        /// <remarks>
-        /// Auto-generated field.
-        /// To modify move field declaration from designer file to code-behind file.
-        /// </remarks>
-        protected global::System.Web.UI.WebControls.Table TableRunDetail;
-    }
-}
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx	(revision 6247)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx	(revision 6253)
@@ -23,11 +23,14 @@
                     <td><%: Html.ActionLink("details", "Details", rvd) %></td>
 
-                    <% foreach (PropertyInfo pi in typeof(RunCollectionData).GetProperties()) {
-                           try { %>
-                    <td><%= pi.GetValue(rcd, null).ToString()%></td>
-                    <%     } catch (Exception e) { %>
-                        &nbsp;</td>
-                    <%     }
-                       } %>
+                    <% foreach (PropertyInfo pi in typeof(RunCollectionData).GetProperties()) { %>
+                    <td>
+                    <%   try { %>
+                         <%= pi.GetValue(rcd, null).ToString()%>
+                    <%   } catch (Exception e) { %>
+                         &nbsp;
+                    <%   } %>
+                    </td>
+
+                    <%   } %>
                 </tr>
                <% } %>